<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_users
 *
 * @copyright   Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

JHtml::_('behavior.keepalive');
JHtml::_('behavior.formvalidation');

JForm::addFieldPath(JPATH_ROOT . '/' . 'templates/'.JFactory::getApplication()->getTemplate().'/html/layouts/libraries/joomla/form/fields');
JForm::addRulePath(JPATH_ROOT . '/' . 'templates/'.JFactory::getApplication()->getTemplate().'/html/layouts/libraries/joomla/form/fields');
?>
<div class="reset-complete<?php echo $this->pageclass_sfx?>">
<div class="page-content">
	<?php if ($this->params->get('show_page_heading')) : ?>
	<div class="page-header"><h1><span>
		<?php echo $this->escape($this->params->get('page_heading')); ?>
	</span></h1></div>
	<?php endif; ?>

	<form action="<?php echo JRoute::_('index.php?option=com_users&task=reset.complete'); ?>" method="post" class="form-validate">

		<?php foreach ($this->form->getFieldsets() as $fieldset) : ?>
		<fieldset>
			<legend class="fs-label"><span><?php echo JText::_($fieldset->label); ?></span></legend>
			<dl>
			<?php foreach ($this->form->getFieldset($fieldset->name) as $name => $field) : ?>
				<dt><?php echo $field->label; ?></dt>
				<dd><?php echo $field->input; ?></dd>
			<?php endforeach; ?>
			</dl>
		</fieldset>
		<?php endforeach; ?>

		<div>
			<button type="submit" class="btn ot-bg validate"><?php echo JText::_('JSUBMIT'); ?></button>
			<?php echo JHtml::_('form.token'); ?>
		</div>
	</form>
</div>
</div>
