<?php
/**
 *
 * Show the products in a category
 *
 * @package    VirtueMart
 * @subpackage
 * @author RolandD
 * @author Max Milbers
 * @todo add pagination
 * @link http://www.virtuemart.net
 * @copyright Copyright (c) 2004 - 2010 VirtueMart Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version $Id: default.php 8508 2014-10-22 18:57:14Z Milbo $
 */

defined ('_JEXEC') or die('Restricted access');
JHtml::_ ('behavior.modal');

$js = "
jQuery(document).ready(function () {
	jQuery('.orderlistcontainer').hover(
		function() { jQuery(this).find('.orderlist').stop().show()},
		function() { jQuery(this).find('.orderlist').stop().hide()}
	)
});
";

vmJsApi::addJScript('vm.hover',$js); ?>
<div class="page-content">
<div class="main-content">
<div class="clearfix"></div>
<?php if (empty($this->keyword) and !empty($this->category)) {
	?>
<?php if (!empty($this->category->category_name)){ ?>
<h3 class="vm-categoryname"><span><?php echo $this->category->category_name; ?></span></h3>
<?php } ?>
<?php if (!empty($this->category->category_description)){ ?>
<div class="category_description">
	<?php echo $this->category->category_description; ?>
</div>
<?php } ?>
<?php
}

// Show child categories
if (VmConfig::get ('showCategory', 1) and empty($this->keyword)) {
	if (!empty($this->category->haschildren)) {

		echo ShopFunctionsF::renderVmSubLayout('categories',array('categories'=>$this->category->children));

	}
}

if($this->showproducts){
?>
<div class="browse-view">
	<?php

	if (!empty($this->keyword)) {?>
		<h4><?php echo $this->keyword; ?></h4>

		<form action="<?php echo JRoute::_ ('index.php?option=com_virtuemart&view=category&limitstart=0', FALSE); ?>" method="get">

			<!--BEGIN Search Box -->
			<div class="virtuemart_search">
				<?php echo $this->searchcustom ?>
				<br/>
				<?php echo $this->searchCustomValues ?>
				<input name="keyword" class="inputbox" type="text" size="20" value="<?php echo $this->keyword ?>"/>
				<input type="submit" value="<?php echo vmText::_ ('COM_VIRTUEMART_SEARCH') ?>" class="button btn ot-bg" onclick="this.form.keyword.focus();"/>
			</div>
			<input type="hidden" name="search" value="true"/>
			<input type="hidden" name="view" value="category"/>
			<input type="hidden" name="option" value="com_virtuemart"/>
			<input type="hidden" name="virtuemart_category_id" value="<?php echo $this->categoryId; ?>"/>

		</form>
		<!-- End Search Box -->
	<?php  } ?>

	<?php // Show child categories
	?>
	<div class="orderby-displaynumber">
		<div class="vm-order-list">
			<?php echo $this->orderByList['orderby']; ?>
			<?php // echo $this->orderByList['manufacturer']; ?>
		</div>
		<div class="display-number">
			<div class="title"><?php echo vmText::_ ('TPL_SHOW'); ?></div>
			<?php echo $this->vmPagination->getLimitBox ($this->category->limit_list_step); ?>
			<?php // echo $this->vmPagination->getResultsCounter ();?>
		</div>
		<div class="clearfix"></div>
	</div> <!-- end of orderby-displaynumber -->
	<?php
	if (!empty($this->products)) {
	$products = array();
	$products[0] = $this->products;
	echo shopFunctionsF::renderVmSubLayout($this->productsLayout,array('products'=>$products,'currency'=>$this->currency,'products_per_row'=>$this->perRow,'showRating'=>$this->showRating));

	?>
	<div class="vm-pagination-bottom">
		<div class="row">
			<div class="col-xs-12 vm-pagination">
				<?php echo $this->vmPagination->getPagesLinks (); ?>
				<?php if($this->vmPagination->getPagesCounter ()) { ?>
					<div class="clearfix"></div>
					<span class="vm-page-counter"><?php echo $this->vmPagination->getPagesCounter (); ?></span>
				<?php } ?>
			</div>
			<div class="clearfix"></div>
		</div>
	</div><div class="clearfix"></div>

	<?php
	} elseif (!empty($this->keyword)) {
		echo vmText::_ ('COM_VIRTUEMART_NO_RESULT') . ($this->keyword ? ' : (' . $this->keyword . ')' : '');
	}
	?>
</div>

<?php } ?>
</div>
</div>
<!-- end browse-view -->